unit ultsTypes;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

type
  {$Z4}
  TltsErrorCode = (
    ltsErrUnknown                   =   -1,
    ltsErrNone                      =    0,

    // misc
    ltsErrNotInitialized            =    1,
    ltsErrInvalidEnum               =    2,
    ltsErrInvalidValue              =    3,
    ltsErrInvalidOperation          =    4,
    ltsErrInvalidType               =    5,

    // invalid handles
    ltsErrInvalidContextHandle      =  100,
    ltsErrInvalidRendererHandle     =  101,
    ltsErrInvalidTextBlockHandle    =  102,
    ltsErrInvalidFontHandle         =  103,
    ltsErrInvalidFontCreatorHandle  =  104,
    ltsErrInvalidImageHandle        =  105,
    ltsErrInvalidPostProcHandle     =  106
  );

  {$Z4}
  TltsObjectType = (
    ltsObjTypeUnknown,
    ltsObjTypeContext,
    ltsObjTypeRenderer,
    ltsObjTypeFontCreator,
    ltsObjTypeFont,
    ltsObjTypeTextBlock,
    ltsObjTypeImage,
    ltsObjTypePostProcessor,
    ltsObjTypeChar
  );

  {$Z4}
  TltsRendererType = (
    ltsRendererUnknown,
    ltsRendererOpenGL,
    ltsRendererOpenGLES
  );

  {$Z4}
  TltsFontCreatorType = (
    ltsFontCreatorUnknown,
    ltsFontCreatorFreeType,
    ltsFontCreatorGDI,
    ltsFontCreatorCustom
  );

  TltsHandle              = Pointer;
  TltsContextHandle       = TltsHandle;
  TltsRendererHandle      = TltsHandle;
  TltsTextBlockHandle     = TltsHandle;
  TltsFontCreatorHandle   = TltsHandle;
  TltsFontHandle          = TltsHandle;
  TltsPostProcessorHandle = TltsHandle;
  TltsImageHandle         = TltsHandle;
  TltsCharHandle          = TltsHandle;

  TltsStreamOrigin = (
    ltsStreamOriginBegin    = Integer(soBeginning),
    ltsStreamOriginCurrent  = Integer(soCurrent),
    ltsStreamOriginEnd      = Integer(soEnd)
  );

  TltsStreamFuncRead = function(const aArgs: Pointer; const aBuffer: Pointer; const aSize: Integer):         Integer; stdcall;
  TltsStreamFuncSeek = function(const aArgs: Pointer; const aOrigin: TltsStreamOrigin; const aPos: Integer): Integer; stdcall;
  PltsStream = ^TltsStream;
  TltsStream = packed record
    args: Pointer;
    read: TltsStreamFuncRead;
    seek: TltsStreamFuncSeek;
  end;

implementation

end.

